#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>

#define INPUTSTRINGLENGTH 1026
#define TIMESTRINGLENGTH 21
#define TIMESTAMPNAME "File update time stamp"

#define LINEFEED 10	/* '\n' */
#define TAB 9	/* '\t' */
#define SPACE 32	/*   */
/* #define COMMENT_TAG 37	% */
#define COMMENT_TAG 33	/* ! */
#define DOUBLEQUOTE 34	/* " */

#define min( a, b ) ((a) < (b) ? (a) : (b))

typedef struct
{
  VAR_NAME name;
  INFOBLOCK
} GENERIC_VAR;

void Initialize();
int ConfigureGeneric( GENERIC_VAR *, char *, char * );
int Configure( GENERIC_VAR * );
int GenerateArrayExtension( char *, char *, int (*function)(), char * );
int ParseConfigLine1( GENERIC_VAR *, char * );
int ParseConfigLine2( GENERIC_VAR *, char * );
int ParseInputLine( GENERIC_VAR *, char * );
int SplitInputString( char *, char *, char **, char ** );
VAR_SET *CreateReadVarSet( char *filename );
VAR_SET *CreateWriteVarSet( char *filename );
VAR_SET *CreateVarSet( char *filename );
char *CreateTimeMark( char * );
void AppendToVarSetList( VAR_SET *var_set, VAR_SET_LIST *var_set_list );
void AppendToVarSet( VAR_NAME *variable, VAR_SET *var_set );
char *GetCommentString( char *);
double ReadVarSet( VAR_SET *);
double OpenReadFile( VAR_SET *var_set, FILE **readfile );
int ReadIntVar( GENERIC_VAR *, char * );
int ReadDoubleVar( GENERIC_VAR *, char * );
int ReadStringVar( GENERIC_VAR *, char * );
int WriteVarSetList( VAR_SET_LIST );
int WriteVarSet( VAR_SET );
int WriteIntVar( VAR_NAME *, FILE * );
int WriteDoubleVar( VAR_NAME *, FILE * );
int WriteStringVar( VAR_NAME *, FILE * );
char *TrimString( char * );
char *ReplaceString( char *, char * );
int IllegalRead( VAR_NAME * );
int IllegalWrite( VAR_NAME * );
char *AddPath( char *, char * );
